#!/usr/bin/python
# -*- coding: utf-8 -*-

# © Jonay Suárez Armas
# All rights reserved. The total or partial reproduction of this work by any
# means or procedure, including printing, reprography, microfilm, computer
# processing or any other system, as well as the distribution of copies by
# rental or loan, is prohibited without the author's written authorization or
# the limits authorized by the Law on Intellectual Property.

import ConfigParser
import pyrebase
import json
import time
import random
import os
import glob

# Import configuration data
config = ConfigParser.ConfigParser()
config.read("config.cfg")

# Instance firebase
config_firebase = {
    "apiKey": "AIzaSyCZ86ZKaI47qZWmS8QSH0t_I2z-9-PcrQA",
    "authDomain": "tfmsensors.firebaseapp.com",
    "databaseURL": "https://tfmsensors.firebaseio.com",
    "storageBucket": "tfmsensors.appspot.com"
}
firebase = pyrebase.initialize_app(config_firebase)

# Authentication
auth = firebase.auth()
user = auth.sign_in_with_email_and_password(config.get("Firebase", "user"), config.get("Firebase", "password"))

database = firebase.database()

# Write device data in Firebase
devId = "/" + user["localId"] + "/devices/" + config.get("General", "id")
database.child(devId).update({"name":config.get("General", "name"), "state":1}, user["idToken"])

# Write sensors in Firebase
os.chdir("emulated_sensors")
dev = "/" + user["localId"] + "/devices/" + config.get("General", "id") + "/sensors/"
try:
    while(True):
        os.system('clear')
        print "-------------------- SENSORS VALUES --------------------"

        for i, file in enumerate(sorted(glob.glob("*.cfg"))):
            # print i, file
            sensor = ConfigParser.ConfigParser()
            sensor.read(file)

            id = sensor.get("Sensor", "id")
            name = sensor.get("Sensor", "name")
            data_type = sensor.get("Sensor", "data_type")
            location_lat = sensor.get("Sensor", "location_lat")
            location_lng = sensor.get("Sensor", "location_lng")
            value = random.randint(int(sensor.get("Sensor", "min_value")), int(sensor.get("Sensor", "max_value")))
            date = time.time()

            last_values = database.child(dev + id + "/last_values").get(user["idToken"]).val()
            if(last_values == None):
                last_values = []
            last_values.append(value)

            # Show only 15 last values
            while(len(last_values) > 15):
                last_values.pop(0)

            sensor_data = {
                "data_type": data_type,
                "date": date,
                "name": name,
                "value": value,
                "last_values": last_values,
                "location": {
                    "lat": location_lat,
                    "lng": location_lng
                }
            }

            result = database.child(dev + "/" + id).update(sensor_data, user["idToken"])
            print result

        time.sleep(2)

finally:
    # Write shutdown state
    database.child(devId).update({"state": 0}, user["idToken"])
    print "-------------------- END OF SIMULATION --------------------"
